// A map of test objects, but make sure that we don't get confused
// if we get the Test proxy or the underlying TestBase.
export class TestMap extends Map {
    get(t) {
        const tt = t.t;
        if (tt !== undefined && tt !== t) {
            let vt = super.get(t.t);
            if (vt === undefined) {
                const v = super.get(t);
                if (v !== undefined) {
                    super.set(tt, v);
                    super.delete(t);
                    return v;
                }
            }
            return vt;
        }
        return super.get(t);
    }
    has(t) {
        const tt = t.t;
        return super.has(t) || super.has(tt);
    }
    set(t, v) {
        const tt = t.t;
        if (tt !== undefined && tt !== t) {
            super.delete(t);
            super.set(tt, v);
        }
        else {
            super.set(t, v);
        }
        return this;
    }
}
//# sourceMappingURL=test-map.js.map